security.d/chk_smart

changeset 5
fe3130d22800
child 12
3179bc45c83c
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/security.d/chk_smart	Wed Jan 14 21:12:35 2009 +0100
@@ -0,0 +1,63 @@
+#!/bin/bash
+#
+# $Id$
+#
+#############################################################################
+# Copyright (C) 2005
+#   
+# Michiel Broek               <mbse@mbse.dds.nl>
+# Beekmansbos 10
+# 1971 BV IJmuiden
+# the Netherlands
+#
+# This file is part of SlackSecCheckSripts.
+#
+# This package is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 2, or (at your option) any
+# later version.
+#
+# SlackSecCheckSripts is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with MBSE BBS; see the file COPYING.  If not, write to the Free
+# Software Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
+#############################################################################
+
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+
+umask 077
+TZ=UTC; export TZ
+LANG=C; export LANG
+
+SECUREDIR=`mktemp -d /tmp/_securedir.XXXXXX` || exit 1
+
+trap "/bin/rm -rf $SECUREDIR ; exit 0" EXIT INT QUIT PIPE
+
+if ! cd "$SECUREDIR"; then
+    echo "Can not cd to $SECUREDIR".
+    exit 1
+fi
+
+TMP=$SECUREDIR/tmp
+
+if [ -x /usr/sbin/smartctl ] && [ -f /etc/smartd.conf ]; then
+    kill -0 `pidof /usr/sbin/smartd` 2>/dev/null
+    if [ "$?" != "0" ]; then
+	printf "\nWarning: smartd is not running.\n"
+    fi
+
+    DISKS=`egrep '^[^#]*(dev)' /etc/smartd.conf | awk '{ print $1 }'`
+    for f in $DISKS ; do
+	# /usr/sbin/smartctl -H -i -l error -l selftest $f
+	/usr/sbin/smartctl -q errorsonly -H -l error $f > $TMP
+	if [ -s $TMP ]; then
+	    printf "\nS.M.A.R.T. error information for disk %s\n\n" $f
+	    cat $TMP
+	fi
+    done
+fi
+

mercurial